#ifndef __ELLIPSE_H
#define __ELLIPSE_H

#include "vector.h"
#include "color.h"

/*楕円面の構造体*/
typedef struct{
	Vector pos;	/* 中心の位置座標 */
	double a;
	double b;
	double c;
	double ka;	/* 環境光係数 */
	double kd;	/* 拡散反射係数 */
	double ks;	/* 鏡面反射係数 */
	double n;	/* Phong係数*/
	Color color;	/* 色 */
}Ellipse;


/*-----------------------------------------------------------------------------
 * double calcCSurfaceT(const Ellipse Obj, const Vector E, const Vector V)
 * 楕円面(Obj)と光線(視点E,方向余弦ベクトルV)の方程式の解Tを求める
 *---------------------------------------------------------------------------*/
extern double calcEllipseT(const Ellipse Obj, const Vector E, const Vector V);

/*-----------------------------------------------------------------------------
 * Vector calcEllipseNorm(const Ellipse Obj, const Vector P)
 * 楕円面（Obj）上の点（P）における単位法線ベクトルを求める
 *---------------------------------------------------------------------------*/
extern Vector calcEllipseNorm(const Ellipse Obj, const Vector P);

#endif

