#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

typedef  struct { double   x, y;       }  VECT2D; 

extern   Display      *dDISPLAY;
extern   Window       rwWINDOW, wWINDOW;
extern   GC           gcGC;
extern   XSetWindowAttributes  attrATTR;
extern	 int 	sSCALE;
extern   int wWidth,wHeight;
extern   Pixmap pmap;

void openwindow(sizex,sizey,name,scale)
	int sizex,sizey,scale;
	char *name;

{

/* ウインドウの生成 */
  sSCALE = scale;
  dDISPLAY  = XOpenDisplay ( NULL );
  rwWINDOW = XDefaultRootWindow ( dDISPLAY );
  wWidth=sizex*sSCALE+(sSCALE-1); 
  wHeight=sizey*sSCALE+(sSCALE-1); 
  wWINDOW  = XCreateSimpleWindow (dDISPLAY, rwWINDOW, 200,200 ,wWidth ,wHeight, 2,
                              WhitePixel( dDISPLAY, 0), BlackPixel ( dDISPLAY, 0 )); 
 
  /* 自動書き換え設定 */
  attrATTR.backing_store = Always;
  XChangeWindowAttributes ( dDISPLAY, wWINDOW, CWBackingStore, &attrATTR );

  XMapWindow ( dDISPLAY, wWINDOW);
  gcGC = XCreateGC ( dDISPLAY, rwWINDOW, 0, 0 );

  /* ウインドウの名前 */
  XStoreName(dDISPLAY,wWINDOW,name);
 /* バッファの作成 */
  pmap=XCreatePixmap(dDISPLAY,wWINDOW,wWidth,wHeight,DefaultDepth(dDISPLAY,0));
  XFillRectangle(dDISPLAY,pmap,gcGC,0,0,wWidth,wHeight);

  XFlush( dDISPLAY );
  /*
    printf("\n");
    printf ( "#### Hit '!' key after window align -> " );
    while ( getchar()!='!' ) {} ;
    printf("\n");
  */
}


void setlinewidth( width)
	int width;
{


/* 線の種類と接続状況の設定 */ 
  XSetLineAttributes(dDISPLAY, gcGC , width, LineSolid, CapButt,JoinMiter);

}



void setfgcolorbyname( name )
	char *name;
{
   Colormap     colmap;
   XColor       col,exact;
  
  /* 色情報　*/ 

  colmap = XDefaultColormap (dDISPLAY,0);
  XAllocNamedColor (dDISPLAY,colmap,name ,&col ,&exact);
  XSetForeground (dDISPLAY, gcGC, col.pixel);

}

void setfgcolorbyRGB( r, g, b )
	int r,g,b;
{
	Colormap colmap;
	XColor col;
	colmap=XDefaultColormap(dDISPLAY, 0);
	col.red  = ((long int )r) << 8;
	col.green= ((long int )g) << 8;
	col.blue = ((long int )b) << 8;
	XAllocColor(dDISPLAY,colmap,&col);
	XSetForeground(dDISPLAY,gcGC,col.pixel);
}


void closewindow()
{

/* 後処理 */


/*  printf("\n");
  printf ( "#### Hit 'q' key to close window -> " );
  while (getchar()!='q') {};
  printf("\n");
*/
  XFreeGC ( dDISPLAY, gcGC );
  XDestroyWindow (dDISPLAY, wWINDOW );

  XFlush ( dDISPLAY );

  XCloseDisplay ( dDISPLAY );    
}

/* ウインドウを保持する(再描画、終了処理を受け持つ) */
void keepwindow(){
  XEvent event;
  int flag=0;
  
  XSelectInput(dDISPLAY,wWINDOW,ExposureMask|KeyReleaseMask);

  while(1){
    XNextEvent(dDISPLAY,&event);
    
    switch(event.type){
    case Expose:XCopyArea(dDISPLAY,pmap,wWINDOW,gcGC,0,0,wWidth,wHeight,0,0);
      break;
    case KeyRelease:flag=1;
      break;
    }

    if(flag==1) break;
  }
}

void setpixel(x,y)
	int x,y;
{
	int i,j;
	for(i=0;i<sSCALE;i++)
	{
		for(j=0;j<sSCALE;j++)
		{
	          XDrawPoint(dDISPLAY,pmap,gcGC,x*sSCALE+i,y*sSCALE+j);
		  XDrawPoint(dDISPLAY,wWINDOW,gcGC,x*sSCALE+i,y*sSCALE+j);
		  /*XCopyArea(dDISPLAY,pmap,wWINDOW,gcGC,0,0,wWidth,wHeight,0,0);*/
		}
	}
	XFlush( dDISPLAY );
}

void clearwindow()
{
	XClearWindow(dDISPLAY,wWINDOW);
}
/* 点を描く */

void drawline(x1,y1,x2,y2)
	int  x1,y1,x2,y2;
{
	XDrawLine(dDISPLAY,wWINDOW,gcGC,(int)(x1*sSCALE),(int)(y1*sSCALE),
                                        (int)(x2*sSCALE),(int)(y2*sSCALE) );
	XFlush(dDISPLAY);
}
