#ifndef __MATRIX_H
#define __MATRIX_H
#include <math.h>
#include "vector.h"

typedef struct{
    double m11,m12,m13;
    double m21,m22,m23;
    double m31,m32,m33;
}Matrix;

/* 単位行列をつくる */
extern Matrix IdentityMatrix;

/* 拡大縮小行列をつくる */
extern Matrix ScaleMatrix(const double scaleX,const double scaleY,const double scaleZ);

/* ベクトル-行列積 */
extern Vector tVectorMatrix(const Vector v,const Matrix m);

/* 行列-ベクトル積 */
extern Vector MatrixVector(const Matrix m,const Vector v);

#endif
