#include <stdio.h>
#include <math.h>

#include "vector.h"
#include "matrix.h"
#include "ellipse.h"

main(){
  Vector E;	/* 視点の座標 */
  Vector R0;
  Vector R1;	/* 視線の終点の座標 */
  Vector V;	/* 視線方向ベクトル */
  Vector C;
  double t;	/* 視点から交点までの距離=２次方程式の解 */
  
  Ellipse Obj;
  
  /*
   * 楕円面の位置座標をキーボード入力する
   * 楕円面のパラメータ(x,y,z軸との交点)をキーボード入力する
   */
  printf("Ellipse x y z ? ");
  scanf ("%lf %lf %lf", &Obj.pos.x, &Obj.pos.y, &Obj.pos.z);
  printf("Ellipse a b c ? ");
  scanf ("%lf %lf %lf", &Obj.a,     &Obj.b,     &Obj.c );
  
  R0.x = 0.0;  R0.y = 0.0;  R0.z = 700.0;
  R1.x = 0.0;  R1.y = 0.0;  R1.z = 0.0;
  
  E = R0;
  V = sub(R1,R0);
  V = normalize(V);

  t = calcEllipseT(Obj,E,V);
  
  /* 交点の座標を求める */
  C = add(E,scale(t,V));

  printf("Ray Eq.\n");
  printf("V = (%f, %f, %f)\n",V.x,V.y,V.z);
  printf("E = (%f, %f, %f)\n",E.x,E.y,E.z);
  printf("Object at ( %f, %f, %f )\n",Obj.pos.x,Obj.pos.y,Obj.pos.z);
  printf("Object parameters: a=%f b=%f c=%f\n",Obj.a,Obj.b,Obj.c);
  if(t>=0.0){
    printf("Intersected at ( %f %f %f )\n", C.x, C.y, C.z);
    printf("Distance=%f \n",t);
  }else{
    printf("No intersection\n");
  }
}
